﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Xceed.Wpf.Toolkit;
using Client.EHEC_Service;
using AutoMapper;

namespace Client
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            // Start Automapper
            Mapper.Initialize(cfg => cfg.AddProfile<AutomapperProfile>());
            // loading of dropdowns

    }

        private void ButtonClose_Click(object sender, RoutedEventArgs e)
        {
            this.Close();
        }
        private void ButtonSend_Click(object sender, RoutedEventArgs e)
        {
            LabelRueckmeldungsfeld.Content = "Sende Daten. ";
            
            Doctor newDoctor = new Doctor(TextboxArztVorname.Text,
                                          TextboxArztName.Text,
                                          TextboxArztStrasseNr.Text,
                                          TextboxArztPlz.Text,
                                          TextboxArztOrt.Text,
                                          TextboxArztRegion.Text,
                                          TextboxArztKantonsarzt.Text
                                          );

            
            Patient newPatient = new Patient(TextboxPatientVorname.Text,
                                             TextboxPatientName.Text,
                                             TextboxPatientStrasseNr.Text,
                                             TextboxPatientPlz.Text,
                                             TextboxPatientOrt.Text,
                                             TextboxPatientRegion.Text,
                                             TextboxPatientGeburtstag.Text
                                             );
            

            Result newResult = new Result(TextboxBakterienstamm.Text);

            LabelRueckmeldungsfeld.Content += "erstelle Doktor, ";
            newDoctor.CreateDoctor();
            LabelArztId.Content = Convert.ToString(newDoctor.Id);

            LabelRueckmeldungsfeld.Content += "erstelle Patient, ";
            newPatient.CreatePatient();
            LabelPatientId.Content = Convert.ToString(newPatient.Id);

            LabelRueckmeldungsfeld.Content += "erstelle Bakterie, ";
            newResult.CreateResult();
            LabelBakterienstamm.Content = Convert.ToString(newResult.Id);

            Exam newExam = new Exam(newDoctor.Id,
                                    newPatient.Id,
                                    newResult.Id
                                    );
            LabelRueckmeldungsfeld.Content += "erstelle Untersuchung, ";
            newExam.CreateExam();
            

            Origin newOrigin1 = new Origin(TextboxNahrung1Restaurant.Text,
                                           TextboxNahrung1Essen.Text,
                                           TextboxNahrung1Strasse.Text,
                                           Convert.ToInt32(TextboxNahrung1Plz.Text),
                                           TextboxNahrung1Ort.Text
                                           );
            
            Origin newOrigin2 = new Origin(TextboxNahrung2Restaurant.Text,
                                           TextboxNahrung2Essen.Text,
                                           TextboxNahrung2Strasse.Text,
                                           Convert.ToInt32(TextboxNahrung2Plz.Text),
                                           TextboxNahrung2Ort.Text
                                           );
            
            Origin newOrigin3 = new Origin(TextboxNahrung3Restaurant.Text,
                                           TextboxNahrung3Essen.Text,
                                           TextboxNahrung3Strasse.Text,
                                           Convert.ToInt32(TextboxNahrung3Plz.Text),
                                           TextboxNahrung3Ort.Text
                                           );
            
            Origin newOrigin4 = new Origin(TextboxNahrung4Restaurant.Text,
                                           TextboxNahrung4Essen.Text,
                                           TextboxNahrung4Strasse.Text,
                                           Convert.ToInt32(TextboxNahrung4Plz.Text),
                                           TextboxNahrung4Ort.Text
                                           );
            
            LabelRueckmeldungsfeld.Content += "erstelle Nahrungsaufnahmen.";

            newOrigin1.CreateOrigin();
            LabelNahrung1Id.Content = Convert.ToString(newOrigin1.Id);

            newOrigin2.CreateOrigin();
            LabelNahrung2Id.Content = Convert.ToString(newOrigin2.Id);

            newOrigin3.CreateOrigin();
            LabelNahrung3Id.Content = Convert.ToString(newOrigin3.Id);

            newOrigin4.CreateOrigin();
            LabelNahrung4Id.Content = Convert.ToString(newOrigin4.Id);

            Origin_Exam newOrigin_Exam1 = new Origin_Exam(newOrigin1.Id,
                                                         newExam.Id
                                                         );

            Origin_Exam newOrigin_Exam2 = new Origin_Exam(newOrigin2.Id,
                                                         newExam.Id
                                                         );

            Origin_Exam newOrigin_Exam3 = new Origin_Exam(newOrigin3.Id,
                                                         newExam.Id
                                                         );

            Origin_Exam newOrigin_Exam4 = new Origin_Exam(newOrigin4.Id,
                                                         newExam.Id
                                                         );

            LabelRueckmeldungsfeld.Content += "Verlinke Nahrungsaufnahmen mit der Untersuchungsnummer.";
            newOrigin_Exam1.CreateOrigin_Exam();
            newOrigin_Exam2.CreateOrigin_Exam();
            newOrigin_Exam3.CreateOrigin_Exam();
            newOrigin_Exam4.CreateOrigin_Exam();
            LabelRueckmeldungsfeld.Content = "Fertig. Behandlung Nr." + Convert.ToString(newExam.Id) + " gespeichert.";
        }

        private void ButtonAutogenerateMany_Click(object sender, RoutedEventArgs e)
        {

        }

        private void ButtonAutogenerateOne_Click(object sender, RoutedEventArgs e)
        {
            TextboxArztName.Text = "doctorLastname";
            TextboxArztVorname.Text = "doctorFirstname";
            TextboxArztStrasseNr.Text = "doctorStreet";
            TextboxArztPlz.Text = "1000";
            TextboxArztOrt.Text = "doctorCity";
            TextboxArztKantonsarzt.Text = "doctorOrigin";
            TextboxArztRegion.Text = "ArztRegion";
            TextboxPatientName.Text = "patientLastname";
            TextboxPatientVorname.Text = "patientFirstname";
            TextboxPatientStrasseNr.Text = "patientStreet";
            TextboxPatientPlz.Text = "2000";
            TextboxPatientOrt.Text = "patientCity";
            TextboxPatientRegion.Text = "patientRegion";
            TextboxPatientGeburtstag.Text = "1.1.2001";
            TextboxBakterienstamm.Text = "bacteriaName";
            TextboxNahrung1Restaurant.Text = "firstRestaurantName";
            TextboxNahrung1Essen.Text = "firstRestaurantFood";
            TextboxNahrung1Strasse.Text = "firstRestaurantStreet";
            TextboxNahrung1Plz.Text = "1111";
            TextboxNahrung1Ort.Text = "firstRestaurantCity";
            TextboxNahrung2Restaurant.Text = "secondRestaurantName";
            TextboxNahrung2Essen.Text = "secondRestaurantFood";
            TextboxNahrung2Strasse.Text = "secondRestaurantStreet";
            TextboxNahrung2Plz.Text = "2222";
            TextboxNahrung2Ort.Text = "secondRestaurantCity";
            TextboxNahrung3Restaurant.Text = "thirdRestaurantName";
            TextboxNahrung3Essen.Text = "thirdRestaurantFood";
            TextboxNahrung3Strasse.Text = "thirdRestaurantStreet";
            TextboxNahrung3Plz.Text = "3333";
            TextboxNahrung3Ort.Text = "thirdRestaurantCity";
            TextboxNahrung4Restaurant.Text = "fourthRestaurantName";
            TextboxNahrung4Essen.Text = "fourthRestaurantFood";
            TextboxNahrung4Strasse.Text = "fourthRestaurantStreet";
            TextboxNahrung4Plz.Text = "4444";
            TextboxNahrung4Ort.Text = "fourthRestaurantCity";
        }
    }




    // aufbewahren für die integration von Id's in die FK Tabellenspalten:
    //try {
    //    Global.GlobalInstance.Service.WritePatient(p);
    //    //servize.WritePatient(p);
    //} catch (Exception) {
    //    if (p.PatientId == 0) {
    //        LabelRueckmeldungsfeld.Content = "fehler id = 0, beim schreiben von Patient!";
    //    } else {
    //        LabelRueckmeldungsfeld.Content = "fehler id != 0, beim schreiben von Patient!";
    //    }
    //}
    //LabelRueckmeldungsfeld.Content = "erfolgreich Patient gespeichert";
    //TextboxPatientName.Clear();


    //private void TextChanged(object sender, KeyboardFocusChangedEventArgs e)
    //{
    //    if (((TextBox)sender).Text.Length == 0)
    //        ((TextBox)sender).Text = ((TextBox)sender).Text.ToString();
    //}

    //private void TextInputs(object sender, EventArgs e)
    //{
    //    if ((((TextBox)sender).Text) == (((TextBox)sender).Text))
    //        ((TextBox)sender).Text = string.Empty;
    //        ((TextBox)sender).SelectionStart = 1;
    //}

    //private void TextboxArztName_LostFocus(object sender, KeyboardFocusChangedEventArgs e) => TextChanged(sender, e);

    //private void TextboxArztName_MouseDown(object sender, MouseButtonEventArgs e)
    //{
    //    TextInputs(sender, e);
    //    //TextboxArztName.Text = string.Empty;
    //}
    //private void TextboxArztName_PreviewTextInput(object sender, TextCompositionEventArgs e)
    //{
    //    TextInputs(sender, e);
    //}


}
